package com.search.supersearch.controller;

import com.search.supersearch.common.R;
import com.search.supersearch.model.pojo.PlatomixDocument;
import com.search.supersearch.model.pojo.PlatomixTemplate;
import com.search.supersearch.service.EsService;
import com.search.supersearch.service.PlatomixDocumentService;
import com.search.supersearch.service.PlatomixTemplateService;
import io.swagger.annotations.Api;
import lombok.SneakyThrows;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Value;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.PathVariable;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

import javax.annotation.Resource;
import java.io.File;

/**
 * @author wangrui
 */
@RestController
@RequestMapping("/es")
@Slf4j
@Api(value = "es 数据初始化", tags = "es 数据初始化")
public class EsInitController {
    @Resource
    private  EsService esService;
    @Value("${blade.file.uploadPath}")
    private String uploadDir;

    @Resource
    private PlatomixTemplateService platomixTemplateService;


    @Resource
    private PlatomixDocumentService platomixDocumentService;

    /**
     * 0.文件待入库
     * 1.正常文件
     * 2. url==null
     * 3.不能解压的压缩文件
     * 4.localOssProcessor文件不存在
     * 5.tika解析异常
     * 6.压缩包文件
     *
     * @return {@link R<?>}
     * @author 王瑞
     * @date 2024/1/25
     */
    @GetMapping("/init/file/v3/{id}")
    @SneakyThrows
    public R<?> initFilev3(@PathVariable("id")String id) {
        PlatomixDocument platomixDocument = platomixDocumentService.getById(id);
        log.info("es data file init ");
        String filePath = uploadDir + platomixDocument.getPath().replace("uploads/", "");

        Integer i = esService.saveFile(new File(filePath), platomixDocument.getCateId().toString(), platomixDocument);
        platomixDocument.setTrans2es(i);
        platomixDocumentService.updateById(platomixDocument);
        return R.data(platomixDocument);
    }

}
